#!/bin/bash
#
# landisk-update.sh
#
# $Id$
#

PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin

. /mnt/hda5/.c4/data/MODEL
MODEL="${model%
}"	# CRコード除去

ROOTPATH='/mnt/hda5/.update'

VERFILE="${ROOTPATH}/for_${MODEL}_series"
VEROUTFILE="/mnt/hda5/.c4/data/MODEL"
UPFILE="/boot/.update/update.tgz"
TARFILE="${ROOTPATH}/update-files.tar.gz"
BETAFILE="${ROOTPATH}/beta"
TMPFILE='/tmp/.landisk-update.sh.tmp'
LOCKDIR='/var/c4/tmp/lock'
CONFTAR="${ROOTPATH}/confupdate.tgz"
CONFDIR='/mnt/hda5/.c4/data/setting/'

UPDATEVER=`sed 's/-.*$//' $VERFILE`
[ -f $BETAFILE ] && BETA=`cat $BETAFILE`

start_led() {
   /usr/local/bin/ledcont progress
}

exit_select() {
#    /usr/local/bin/ledcont errfastblink
#    /usr/local/bin/buzcont 10 50 3
    rm -rf $LOCKDIR
    exit $1
}

###############################################################################
# conffilesの更新
###############################################################################
__update_conffiles() {
	local f=''
	local verup_files='ddns remotelink mywebserver'

	# conffilesの追加
	for f in $verup_files
	do
		if [ ! -e $CONFDIR/$f ]; then
			tar xpzf ${CONFTAR} \
			-C /mnt/hda5 .c4/data/setting/$f ||return 1
		fi
	done
}

###############################################################################
# website.conf が存在しなければtouch する
###############################################################################
__website_conf() {
	local website_conf='/etc/apache2/website.conf'

	# conffilesの追加
	if [ ! -e $website_conf ]; then
		touch $website_conf ||return 1
	fi
	return 0
}

########################
# start
start_led

# perlでアップデート
# ${UPPERL} --update
# if [ $? != 0 ]; then
#    exit_select 3
# fi

# サービスの停止の布石
# SERVICE=`${UPPERL} --getservice 2>/dev/null | awk -F '=' '{print $1}'`
# remount rw /
mount -o remount,rw,noatime /
mount -o remount,rw,noatime /boot

# サービスの停止
for i in apache2 samba slpd netatalk mt-daapd dlna HDLFind.sh cron networking tms webaccess
do
    /etc/init.d/$i stop
done

# 必要であれば
#killall buttond
#killall usbhdmng

# tarで展開
tar xpzf ${TARFILE} -C / --exclude=./mnt/hda5/webaccess/smbweb.ini \
			--exclude=./mnt/hda5/webaccess/sharelst.txt \
			--exclude=./mnt/hda5/tms/tms.ini \
			|| exit_select 1
# keep old files
tar xpkzf ${TARFILE} -C / ./mnt/hda5/webaccess/smbweb.ini \
			./mnt/hda5/webaccess/sharelst.txt \
			./mnt/hda5/tms/tms.ini

__update_conffiles || exit_select 1
__website_conf || exit_select 1

# ファイルを削除する
rm -f $TARFILE $BETAFILE $VERFILE $CONFTAR

# 終了処理
upver="$UPDATEVER"
[ "$UPDATESUBVER" != "" ] && upver="$upver-$UPDATESUBVER"
[ "x$BETA" != "x" ] && upver="$upver beta$BETA"

# version編集
echo "model=$MODEL" > $TMPFILE
echo "version=$upver" >> $TMPFILE
mv $TMPFILE $VEROUTFILE || exit_select 2
chown root:root $VEROUTFILE
chmod 777 $VEROUTFILE
echo "UPDATE->$upver" >/dev/console
echo "success($UPDATEVER)" > /mnt/hda5/.update/update.log
